package cv3;
 
import cv3.Bicycle.Color;
import cv3.servis.BasicServis;
import cv3.servis.BicycleVisitor;
import cv3.servis.MountainBikeBasicServis;
import cv3.servis.RoadBikeBasicServis;
 
public class TestBikes {
    public static void main(String[] args) {
        Bicycle bike01, bike02, bike03;
 
        bike01 = new Bicycle(20, 10, 1, Color.Blue);
        bike02 = new MountainBike(20, 10, 5, Color.Green, "Dual");
        bike03 = new RoadBike(40, 20, 8, Color.Red, 23);
 
        bike01.printDescription();
        bike02.printDescription();
        bike03.printDescription();
 
        BicycleVisitor servis1 = new BasicServis();
        BicycleVisitor servis2 = new MountainBikeBasicServis();
        BicycleVisitor servis3 = new RoadBikeBasicServis();
 
        System.out.println("\nSingle dispatch");
        // prvni pokus - nefunguje
        servis1.accept(bike01);
        servis2.accept(bike02);
        servis3.accept(bike03);
 
        System.out.println("\nDouble dispatch");
        // druhy pokus
        bike01.visit(servis1);
        bike02.visit(servis2);
        bike03.visit(servis3);
 
        // prvni pokus - nefunguje
        //        BicycleHolder holder1 = new BicycleHolder(bike01);
        //        BicycleHolder holder2 = new MountainBikeHolder(bike02);
        //        BicycleHolder holder3 = new RoadBikeHolder(bike03);
 
        Car car = new Car();
        // druhy pokus
        bike01.visit(car);
        bike02.visit(car);
        bike03.visit(car);
 
        System.out.println("\nCar");
        car.print();
 
        CarWithAGenericHolder carWithAGenericHolder = new CarWithAGenericHolder();
        // druhy pokus
        bike01.visit(carWithAGenericHolder);
        bike02.visit(carWithAGenericHolder);
        bike03.visit(carWithAGenericHolder);
 
        System.out.println("\nCarWithAGenericHolder");
        carWithAGenericHolder.print();
 
    }
}
